;;*****************************************************************************
;;*****************************************************************************
;;  FILENAME: Timer8_1INT.asm
;;   Version: 2.5, Updated on 2006/06/19 at 11:15:48
;;  Generated by PSoC Designer ver 4.3  b1884 : 23 June, 2006
;;
;;  DESCRIPTION: Timer8 Interrupt Service Routine
;;-----------------------------------------------------------------------------
;;  Copyright (c) Cypress MicroSystems 2000-2004. All Rights Reserved.
;;*****************************************************************************
;;*****************************************************************************

include "m8c.inc"
include "memory.inc"
include "Timer8_1.inc"


;-----------------------------------------------
;  Global Symbols
;-----------------------------------------------
export  _Timer8_1_ISR


AREA InterruptRAM (RAM,REL,CON)

;@PSoC_UserCode_INIT@ (Do not change this line.)
;---------------------------------------------------
; Insert your custom declarations below this banner
;---------------------------------------------------

;------------------------
; Includes
;------------------------

	
;------------------------
;  Constant Definitions
;------------------------


;------------------------
; Variable Allocation
;------------------------
aa::		BLK	1	;offset for "jmp" instruction
ai::		BLK	1	;current address in pattern buffer
an::		BLK	6	;pattern buffer
key_cnt::	BLK	1	;counter for checking of keypress 

;---------------------------------------------------
; Insert your custom declarations above this banner
;---------------------------------------------------
;@PSoC_UserCode_END@ (Do not change this line.)


AREA UserModules (ROM, REL)

;-----------------------------------------------------------------------------
;  FUNCTION NAME: _Timer8_1_ISR
;
;  DESCRIPTION: Unless modified, this implements only a null handler stub.
;
;-----------------------------------------------------------------------------
;

_Timer8_1_ISR:

   ;@PSoC_UserCode_BODY@ (Do not change this line.)
    push A
    push X

;-------------------- dinamic indication -------------------
	mov reg[PRT1DR],0b10111100	;turn off all digits, set P1[7] and P1[5] high (buttons)
    mvi A,[ai]					;load char image from buffer
    nop							;(no inversion)
    mov reg[PRT2DR],A			;turn on the segments

	mov A,[aa]					;load offset
	jacc c_1					;and turn on the digit (go to one of labels c_1 ... c_6)
c_1:mov reg[PRT1DR],0b10100000	;turn on 1st digit
	jmp task1	;run task1
c_2:mov reg[PRT1DR],0b10100100	;turn on 2nd digit
	jmp c_end	;no task2
c_3:mov reg[PRT1DR],0b10101000	;turn on 3rd digit
	jmp c_end	;no task3
c_4:mov reg[PRT1DR],0b10101100	;turn on 4th digit
	jmp c_end	;no task4
c_5:mov reg[PRT1DR],0b10110000	;turn on 5th digit
	jmp c_end	;no task5
c_6:mov reg[PRT1DR],0b10110100	;turn on 6th digit
	jmp c_end	;no task6
c_end:
	add [aa],(c_2-c_1)			;next offset
	cmp [ai],an+6				;check position
	jnz c_end2					;not all the digits are multiplexed
		mov [aa],0					;else load start offset
		mov [ai],an					;and load start position
	c_end2:

    pop X
    pop A   
    reti


;--------------------- 1 task ---------------------------
task1:	;check buttons and set flags
	;tst reg[PRT1DR],0b10000000	;check P1[7] and P1[5]
	mov A,reg[PRT1DR]	;check P1[7] and P1[5]
	cpl
	and A,0b10100000
	jz	task1_1			;if not pressed
		inc [key_cnt]
		tst [key_cnt],10h
		jz task1_end		;if cycles < 16
		and [key_cnt],F0h	;clear 3...0 bits

 		rlc A			;check bit 7
 		jc task1_2
  		rlc A			;check bit 5
  		rlc A
 		jc task1_3
		jmp task1_end

 		task1_2:
			or  [key_cnt],80h	;set "Button P1[7]" flag
			;show "CAL.20" message
		    mov [an+0],39h	;C
   		 	mov [an+1],77h	;A
    		mov [an+2],B8h	;L.
    		mov [an+3],5Bh	;2
    		mov [an+4],3Fh	;0
    		mov [an+5],00h	;
			jmp task1_end

 		task1_3:
			or  [key_cnt],40h	;set "Button P1[5]" flag
			;show "CAL.100" message
			mov [an+0],39h	;C
    		mov [an+1],77h	;A
    		mov [an+2],B8h	;L.
    		mov [an+3],06h	;1
    		mov [an+4],3Fh	;0
    		mov [an+5],3Fh	;0
			jmp task1_end

	task1_1:
		inc [key_cnt]
		tst [key_cnt],10h
		jnz task1_end		;if cycles < 16
		and [key_cnt],C0h	;clear 5...0 bits
	task1_end:
	jmp c_end
;--------------------- 2 task ---------------------------
task2:
	jmp c_end
;--------------------- 3 task ---------------------------
task3:
	jmp c_end
;--------------------- 4 task ---------------------------
task4:
	jmp c_end
;--------------------- 5 task ---------------------------
task5:
	jmp c_end
;--------------------- 6 task ---------------------------
task6:
	jmp c_end

;-------------------- end of tasks ----------------------
   ;@PSoC_UserCode_END@ (Do not change this line.)

   reti


; end of file Timer8_1INT.asm
